/*( -w -O1 )*/

// scorrect g[rR[ht@C̃`FbNT𐳂B

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <stdarg.h>
#include <string.h>

char Version[]=
	"scorrect Motorola S-Record file checksum corrector. 0.01";

#define BUFF_SIZE ((255+2)*2+2)

void pexit( char *format, ... )
{
	va_list ap;
	fprintf(stderr,"Error: ");
	va_start(ap,format);
	vfprintf(stderr, format,ap);
	va_end(ap);
	fprintf(stderr,"\n");
//	fcloseall();
	exit(1);
}


int isXdigit(register int c)
{
	if (c>='0' && c<='9') return 1;
	c |= 0x20;
	if (c>='a'&&c<='f' ) return 1;
	return 0;
}

int hextoNib(register int c )	/* '0' ` 'F'  0x00 ` 0x0f	*/
{
	int i;
	c|=0x20;
	if (c>='0' && c<='9') i=(c-'0');
	else if (c>='a'&&c<='f' ) i = c-('a'-10);
	else i = -1;
//	printf("hextoNib() returns %d\n",i);
	return i;
}

int toByte(register const char *hex)
{
	return ( hextoNib(*hex)<<4 )|hextoNib(*(hex+1)) ;
}

char * toHex(register  int b,register char *str)
// b̉޲  strͷɂē.̕ւ߲Ԃ
{
	static char hex[]="0123456789ABCDEF";
	*str++=hex[(b>>4) & 0x0f];
	*str++=hex[b & 0x0f];
	return str;
}


int calcChecksum(register const char *hex)
{
	int sum;
	for(sum=0; isXdigit(*hex) && isXdigit(*(hex+1)) ;hex+=2)
	{
		sum += toByte(hex);
	}
	sum &= 0xff;
	return sum;
}

void recalcSum(register char *hex)
{
	int sum,nbytes;
	sum=toByte(hex); hex+=2;
	for(nbytes=sum-1; nbytes>0;nbytes--)
	{
		sum += toByte(hex);
		hex+=2;
	}
	sum = 0xff - ( sum & 0xFF);
	*toHex( sum,hex) = '\0';
}

int srecSumCorrect( FILE *fpIn,FILE *fpOut )
{
	char buff[BUFF_SIZE];
	int lineRead;
	int lineCorrected;
	lineRead=lineCorrected=0;
	while( fgets(buff,BUFF_SIZE,fpIn) )
	{
		int lenline;
		lineRead++;
		if( (lenline=strlen(buff))>(BUFF_SIZE-2) )
			pexit("Too long line %d.",lenline);
		else if(buff[0] !='S') continue;
		lenline--;
		buff[lenline]='\0';
		// printf("[%s] (%d)\n",buff,lenline);
		if( lenline< 10	 )
			pexit("Too short line %d.",lineRead);
		// printf("toByte(&buff[2]) = %d\n",toByte(&buff[2]));
		if( lenline != toByte(&buff[2])*2 + 4)
			pexit("Illegal line %d.",lineRead);
		if( calcChecksum (&buff[2])!= 0xFF)
		{
			recalcSum(&buff[2]);
			lineCorrected++;
		}
		if(fprintf(fpOut,"%s\n",buff)==EOF)
			pexit("write file failed.");
	}
	fclose(fpOut);
	fclose(fpIn);
	fprintf(stderr,"Read %d lines.  Corrected %d lines.\n",
		lineRead,lineCorrected);
	return 0;
}


int	 main( int ac, char *av[])
{
	FILE *fpIn, *fpOut;
	fprintf(stderr,"%s\n",Version);
	fpIn=stdin;
	fpOut=stdout;
	if(ac >1)
	{
		if ((fpIn = fopen(av[1],"rt")) == NULL)	// ̧
			pexit("Input file[%s] open failed.",av[1] );
	}
	if(ac > 2)
	{
		if ((fpOut = fopen(av[2],"wt")) == NULL)	// o̧
			pexit("Output file[%s] open failed.",av[2] );
	}
	return srecSumCorrect( fpIn,fpOut );
}

